/**
 * KIELER - Kiel Integrated Environment for Layout Eclipse RichClient
 * 
 * http://www.informatik.uni-kiel.de/rtsys/kieler/
 * 
 * Copyright 2014 by
 * + Kiel University
 *   + Department of Computer Science
 *     + Real-Time and Embedded Systems Group
 * 
 * This code is provided under the terms of the Eclipse Public License (EPL).
 * See the file epl-v10.html for the license text.
 */
package de.cau.cs.kieler.kiml.formats.gml;

import de.cau.cs.kieler.kiml.formats.gml.Element;
import java.util.List;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;

/**
 * Root element of GML models. Inherits from {@link EObjectImpl}
 * such that it can be used within an EMF context.
 */
@SuppressWarnings("all")
public class GMLModel extends EObjectImpl {
  private List<Element> elements = CollectionLiterals.<Element>newArrayList();
  
  public List<Element> getElements() {
    return this.elements;
  }
  
  public String toString() {
    final Function1<Element, String> _function = new Function1<Element, String>() {
      public String apply(final Element it) {
        return it.toString();
      }
    };
    List<String> _map = ListExtensions.<Element, String>map(this.elements, _function);
    String _join = IterableExtensions.join(_map, ",\n");
    String _plus = ("[\n" + _join);
    return (_plus + "\n]");
  }
}
