/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.graphdrawing.graphml;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Key For Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 *       Simple type for the for attribute of &lt;key&gt;.
 *       key.for.type is a restriction of xs:NMTOKEN
 *       Allowed values: all, graph, node, edge, hyperedge, port and endpoint.
 *     
 * <!-- end-model-doc -->
 * @see org.graphdrawing.graphml.GraphMLPackage#getKeyForType()
 * @model extendedMetaData="name='key.for.type'"
 * @generated
 */
public enum KeyForType implements Enumerator {
    /**
     * The '<em><b>All</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ALL_VALUE
     * @generated
     * @ordered
     */
    ALL(0, "all", "all"),

    /**
     * The '<em><b>Graphml</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #GRAPHML_VALUE
     * @generated
     * @ordered
     */
    GRAPHML(1, "graphml", "graphml"),

    /**
     * The '<em><b>Graph</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #GRAPH_VALUE
     * @generated
     * @ordered
     */
    GRAPH(2, "graph", "graph"),

    /**
     * The '<em><b>Node</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #NODE_VALUE
     * @generated
     * @ordered
     */
    NODE(3, "node", "node"),

    /**
     * The '<em><b>Edge</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #EDGE_VALUE
     * @generated
     * @ordered
     */
    EDGE(4, "edge", "edge"),

    /**
     * The '<em><b>Hyperedge</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #HYPEREDGE_VALUE
     * @generated
     * @ordered
     */
    HYPEREDGE(5, "hyperedge", "hyperedge"),

    /**
     * The '<em><b>Port</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #PORT_VALUE
     * @generated
     * @ordered
     */
    PORT(6, "port", "port"),

    /**
     * The '<em><b>Endpoint</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ENDPOINT_VALUE
     * @generated
     * @ordered
     */
    ENDPOINT(7, "endpoint", "endpoint");

    /**
     * The '<em><b>All</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>All</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #ALL
     * @model name="all"
     * @generated
     * @ordered
     */
    public static final int ALL_VALUE = 0;

    /**
     * The '<em><b>Graphml</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Graphml</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #GRAPHML
     * @model name="graphml"
     * @generated
     * @ordered
     */
    public static final int GRAPHML_VALUE = 1;

    /**
     * The '<em><b>Graph</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Graph</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #GRAPH
     * @model name="graph"
     * @generated
     * @ordered
     */
    public static final int GRAPH_VALUE = 2;

    /**
     * The '<em><b>Node</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Node</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #NODE
     * @model name="node"
     * @generated
     * @ordered
     */
    public static final int NODE_VALUE = 3;

    /**
     * The '<em><b>Edge</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Edge</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #EDGE
     * @model name="edge"
     * @generated
     * @ordered
     */
    public static final int EDGE_VALUE = 4;

    /**
     * The '<em><b>Hyperedge</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Hyperedge</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #HYPEREDGE
     * @model name="hyperedge"
     * @generated
     * @ordered
     */
    public static final int HYPEREDGE_VALUE = 5;

    /**
     * The '<em><b>Port</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Port</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #PORT
     * @model name="port"
     * @generated
     * @ordered
     */
    public static final int PORT_VALUE = 6;

    /**
     * The '<em><b>Endpoint</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Endpoint</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #ENDPOINT
     * @model name="endpoint"
     * @generated
     * @ordered
     */
    public static final int ENDPOINT_VALUE = 7;

    /**
     * An array of all the '<em><b>Key For Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static final KeyForType[] VALUES_ARRAY =
        new KeyForType[] {
            ALL,
            GRAPHML,
            GRAPH,
            NODE,
            EDGE,
            HYPEREDGE,
            PORT,
            ENDPOINT,
        };

    /**
     * A public read-only list of all the '<em><b>Key For Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final List<KeyForType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
     * Returns the '<em><b>Key For Type</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static KeyForType get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            KeyForType result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Key For Type</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static KeyForType getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            KeyForType result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Key For Type</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static KeyForType get(int value) {
        switch (value) {
            case ALL_VALUE: return ALL;
            case GRAPHML_VALUE: return GRAPHML;
            case GRAPH_VALUE: return GRAPH;
            case NODE_VALUE: return NODE;
            case EDGE_VALUE: return EDGE;
            case HYPEREDGE_VALUE: return HYPEREDGE;
            case PORT_VALUE: return PORT;
            case ENDPOINT_VALUE: return ENDPOINT;
        }
        return null;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final int value;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final String name;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private final String literal;

    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private KeyForType(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public int getValue() {
      return value;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getName() {
      return name;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getLiteral() {
      return literal;
    }

    /**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        return literal;
    }
    
} //KeyForType
